/*
**    TP CPE Lyon
**    Copyright (C) 2013 Damien Rohmer
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**   This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/




#include <pos2.hpp>

namespace cpe
{


    pos2::pos2(int x0,int y0)
        :internal_x(x0),internal_y(y0)
    {}

    int pos2::x() const{return internal_x;}
    int& pos2::x(){return internal_x;}
    int pos2::y() const{return internal_y;}
    int& pos2::y(){return internal_y;}

    std::ostream& operator<<(std::ostream& stream,const pos2& u)
    {
        stream<<"("<<u.x()<<" ; "<<u.y()<<")";
        return stream;
    }

    pos2& operator+=(pos2& u1,const pos2& u2)
    {
        u1.x()+=u2.x();
        u1.y()+=u2.y();
        return u1;
    }
    pos2& operator-=(pos2& u1,const pos2& u2)
    {
        u1.x()-=u2.x();
        u1.y()-=u2.y();
        return u1;
    }

    pos2 operator+(const pos2& u1,const pos2& u2)
    {
        pos2 u=u1;
        u+=u2;
        return u;
    }
    pos2 operator-(const pos2& u1,const pos2& u2)
    {
        pos2 u=u1;
        u-=u2;
        return u;
    }


}
