/*
**    TP CPE Lyon
**    Copyright (C) 2013 Damien Rohmer
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**   This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <sphere.hpp>
#include <ray.hpp>
#include <intersection.hpp>

#include <cmath>
#include <cstdlib>


namespace cpe
{
    sphere::sphere(const vec3& center_data,float radius_data):x0(center_data),r(radius_data){}
    sphere::~sphere(){}

    double sphere::radius() const{return r;}
    const vec3& sphere::center() const{return x0;}

    bool sphere::intersect(const ray& ray_data,intersection& intersection_data) const
    {
        const vec3& ray_x0=ray_data.x0;
        const vec3& ray_u=ray_data.u;

        // ********************************************************** //
        // ********************************************************** //
        //  TO DO:
        //    Calcul d'intersection entre un rayon et une plan
        //
        // Variales:
        //  - Position initiale du rayon: ray_x0
        //  - Vecteur directeur unitaire du rayon: ray_u
        //  - Position du centre de la sphere: x0
        //  - Rayon de la sphere: r
        //
        // Aide de syntaxe:
        //  - Norme au carre d'un vecteur v: float norme=v.norm2();
        //             ou: float norme=v.dot(v);
        //
        // ********************************************************** //
        // ********************************************************** //



        //Le code suivant est arbitraire est doit etre modifie
        float f=sqrt(4*(ray_x0-x0).dot(ray_u)*(ray_x0-1.1*x0).dot(ray_u)-3.5*ray_u.dot(ray_u)*((ray_x0-x0).dot(ray_x0-x0)));
        if(f>2.5)
        {
            return true;
        }
        return false;


    }
}
