/*
**    TP CPE Lyon
**    Copyright (C) 2013 Damien Rohmer
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**   This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <intersection.hpp>


namespace cpe
{
intersection::intersection(const vec3& x_data,const vec3& n_data,double t_data)
    :x(x_data),n(n_data),t(t_data)
{}

void intersection::set(const vec3& x_data,const vec3& n_data,double t_data)
{
    x=x_data;
    n=n_data;
    t=t_data;
}

void intersection::set(const intersection& inter)
{
    x=inter.x;
    n=inter.n;
    t=inter.t;
}

std::ostream& operator<<(std::ostream& stream,const intersection& inter)
{
    stream<<inter.x<<" "<<inter.n<<" "<<inter.t<<std::endl;
    return stream;
}

}
