/*
**    TP CPE Lyon
**    Copyright (C) 2013 Damien Rohmer
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**   This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <ray_generator.hpp>

#include <vec3.hpp>

#include <assert.h>

namespace cpe
{


ray ray_generate(float kx,float ky,int Nx,int Ny,const camera& cam)
{
    assert(Nx>0);
    assert(Ny>0);

    float u=kx/(Nx-1.0);
    float v=ky/(Ny-1.0);

    vec3 p=screen_position(cam,u,v)-cam.get_center();

    return ray(cam.get_center(),p);
}

}
