/*
**    TP CPE Lyon
**    Copyright (C) 2013 Damien Rohmer
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**   This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef LIGHT_HPP
#define LIGHT_HPP


#include <vec3.hpp>
#include <color.hpp>

namespace cpe
{
/** \brief Container of a light*/
struct light
{
    /** \brief direct constructor */
    light(const vec3& position=vec3(),const color& c=color(1,1,1),float power=1.0);

    /** \brief light position */
    vec3 p;
    /** \brief light color */
    color c;
    /** \brief light power */
    float power;
};
}

#endif
