/*
**    TP CPE Lyon
**    Copyright (C) 2013 Damien Rohmer
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**   This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef VERTEX_HPP
#define VERTEX_HPP

#include <vec3.hpp>
#include <color.hpp>

namespace cpe
{

/** \brief A vertex structure containing a position, normal, and a color */
struct vertex
{
    /** \brief Direct constructor from a position, normal and color */
    vertex(const vec3& position,const vec3& normal,const color& col);

    /** \brief the 3D position */
    vec3 p;
    /** \brief the normal */
    vec3 n;
    /** \brief the color */
    color c;
};
}

#endif
